' O2common.inc
' These are the commonly use functions and macros
' Updated :  Nov 14 2018

#lookahead
uses Corewin

 ' Background color for main window
int  MainWindBGColor
sys hBGDC

' Trim function
 def Trim ltrim(rtrim(%1))

'  Variant pointer
   def varptr @ %1

 ' PB CODEPTR function
  def codeptr @ %1

'  Carriage return character
   string  cr = chr(13,10)


'  Font Weights 
% FW_DONTCARE   = 0
% FW_THIN       = 100
% FW_EXTRALIGHT = 200
% FW_LIGHT      = 300
% FW_NORMAL     = 400
% FW_MEDIUM     = 500
% FW_SEMIBOLD   = 600
% FW_BOLD       = 700
% FW_EXTRABOLD  = 800
%  FW_HEAVY      = 900
% LOGPIXELSY 90


% HWND_DESKTOP  0
% DS_CENTER =0x0800
% DS_MODALFRAME=0x80
% SS_CENTERIMAGE=0x200

%  WM_SIZING           = &H214
%  WM_MOVING           = &H216

% NM_CLICK  -2
%  CDRF_NOTIFYSUBITEMDRAW  = &H20
%  CDDS_SUBITEM = &H20000

% CDRF_DODEFAULT          = &H00000000
% CDRF_DOERASE              =  &H00000004

% LR_LOADFROMFILE=0x0010
% IMAGE_ICON=1
% STM_SETIMAGE=0x172
% SWP_NOZORDER=4 

%  COLOR_WINDOW               = 5
% COLOR_WINDOWTEXT           = 8
% COLOR_HIGHLIGHT            = 13
% COLOR_HIGHLIGHTTEXT        = 14


' for subclassing
%  CLR_NONE = &HFFFFFFFF
%  GWLP_WNDPROC= dword -4


' Statusbar
% SB_SETPARTS 0x404
% SB_SETTEXT 0x401
% SBS_SIZEGRIP 16
% CCS_BOTTOM 3


'  for icons
   % ICON_BIG=1
   % WM_SETICON=0x80



  
' the following codes is related to getting date and time
' https://www.oxygenbasic.org/forum/index.php?topic=810.msg6615#msg6615
Type SYSTEMTIME
     word wYear 
     word wMonth
     word wDayOfWeek
     word wDay   
     word wHour   
     word wMinute
     word wSecond
     word wMilliseconds
End Type



! GetDlgItem lib "user32.dll" (sys hDlg, int nIDDlgItem) as sys
! IsDialogMessage lib "user32.dll" alias"IsDialogMessageA" (sys hDlg, sys lpMsg) as bool
! IsWindow lib "user32.dll" (sys hWnd) as bool




'===============================  
' for displaying the RGB colors 
Function RGB(sys wred,wgreen,wblue) as sys
  sys wcolor
  wcolor = wred
  wcolor = wcolor + wgreen*256
  wcolor = wcolor + wblue*65536
  Return wcolor
End Function 



'======================================== 
' draws with color gradient
SUB DrawGradient (BYVAL hBGDC AS sys)
   LOCAL rectFill AS RECT, rectClient AS RECT, fStep AS SINGLE
   local hBrush AS sys, lOnBand AS LONG
   GetClientRect WindowFromDC(hBGDC), rectClient
   fStep = rectClient.bottom / 75

   FOR lOnBand = 0 TO  30    ' 50 
      SetRect rectFill, 0, lOnBand * fStep, rectClient.right + 1, (lOnBand + 1) * fStep
      ' paint the background -- change the first 2 colors R and G
      ' to vary the color gradient

    Select case MainWindBGColor
      Case 1
      ' this gives a light yellow background
       hBrush = CreateSolidBrush(rgb(255, 255, 205 - lOnBand))
      Case 2
     ' this gives a cyan background
       hBrush = CreateSolidBrush(rgb(0, 248, 255 - lOnBand))

      Case 3
      ' this gives a light green background
        hBrush = CreateSolidBrush(rgb(155, 250, 147 - lOnBand))
      Case 4
    ' this gives a PaleTurquoise background
        hBrush = CreateSolidBrush(rgb(175,238,238 - lOnBand))

   Case 5
      ' this gives a MintCream background
        hBrush = CreateSolidBrush(rgb( 245,255,250 - lOnBand))
   Case 6
      ' this gives a OldLace background
        hBrush = CreateSolidBrush(rgb(253,245,230 - lOnBand))
   Case 7
      ' this gives a honeydew background
        hBrush = CreateSolidBrush(rgb(240,255,240 - lOnBand))
   Case 8
      ' this gives a lightcyan background
        hBrush = CreateSolidBrush(rgb(224,255,255 - lOnBand))

   Case 9
      ' this gives a PapayaWhip background
        hBrush = CreateSolidBrush(rgb(255,239,213- lOnBand))
   Case 10
      ' this gives a Cornsilk background
        hBrush = CreateSolidBrush(rgb( 255,248,220 - lOnBand))

      Case 11
      ' this gives a Azure background
        hBrush = CreateSolidBrush(rgb(240,255,255 - lOnBand))
      Case 12
      ' this gives a AliceBlue background
        hBrush = CreateSolidBrush(rgb(240,248,255 - lOnBand))

      Case 13
      ' this gives a Aquamarine  background
        hBrush = CreateSolidBrush(rgb( 127,255,212 - lOnBand))
     Case 14
      ' this gives a LightGoldenrodYellow background
        hBrush = CreateSolidBrush(rgb(   250,250,210 - lOnBand))
    Case 15
      ' this gives a Lavender background
        hBrush = CreateSolidBrush(rgb(230,230,250   - lOnBand))

    End Select

      Fillrect hBGDC, rectFill, hBrush
      DeleteObject hBrush
   NEXT

END SUB




'==============================================================================
Function O2ApiCreateFont(szFaceName As Zstring,Byval lPointSize As long, BYVAL lWeight     AS LONG) As sys
    Dim tlf As LOGFONT
    Dim Fhdc As sys
    Dim nNum As long
    Fhdc = GetDc(%HWND_DESKTOP)
    nNum = GetDeviceCaps(Fhdc, %LOGPIXELSY)
    tlf.lfHeight         = -MulDiv(lPointSize,nNum , 72)
    tlf.lfWidth          =  0
    tlf.lfEscapement     =  0
    tlf.lfOrientation    =  0
    tlf.lfWeight         = lWeight 
    tlf.lfItalic         =  0
    tlf.lfUnderline      =  0
    tlf.lfStrikeOut      =  0
    tlf.lfCharSet        =  %ANSI_CHARSET
    tlf.lfOutPrecision   =  %OUT_TT_PRECIS
    tlf.lfClipPrecision  =  %CLIP_DEFAULT_PRECIS
    tlf.lfQuality        =  %DEFAULT_QUALITY
    tlf.lfPitchAndFamily =  %FF_DONTCARE
    tlf.lfFaceName       =  szFaceName
    ReleaseDC(%HWND_DESKTOP, Fhdc)
Function = CreateFontIndirect(@tlf)
End Function





